// National Flags by Pecon7

$temp::fileCount = getFileCount("add-ons/Server_NationalFlags/flags/*");

for(%i = 0; %i < $temp::fileCount; %i++)
{
	%texture = findNextFile("add-ons/Server_NationalFlags/flags/*");
	%flag = FileBase(%texture);
	
	eval("datablock particleData(bitmapFlag" @ %flag @ "data){textureName=\"" @ %texture @ "\";};");
	//echo("Created" SPC %flag SPC "flag." SPC %texture);
}


package NationalFlagsPackage
{
   function gameConnection::AutoAdminCheck(%this)
	{
		schedule(500, %this, startNationalFlagSearch, %this);
		Parent::autoAdminCheck(%this);
		%this.clanPrefix = "<bitmap:" @ "add-ons/Server_NationalFlags/flags/default" @ ">" @ %this.clanPrefix;
	}
};
activatepackage(NationalFlagsPackage);

function startNationalFlagSearch(%client)
{
	%ip = %client.getrawIP();
	
	if(isObject($FlagFinderObject))
	{
		schedule(1000, %client, startNationalFlagSearch, %client);
		//echo("Flag search quota delayed");
		return;
	}
	
	$FlagFinderObject = new HTTPObject(FlagTraceIPClass)
	{
		ip = %ip;
		client = %client;
	};
	
	if(%ip !$= "local")
		$FlagFinderObject.get("ipinfo.io:80","/" @ %ip @ "/country");
		
	else
		$FlagFinderObject.get("ipinfo.io:80","/country");
	
	$FlagFinderObject.schedule(30000, delete);
}

function FlagTraceIPClass::onLine(%this, %line)
{
	%name = trim(%line);
		
	echo("Country:" SPC %name);
	
	%flag = matchFlagbyName(%name);
	%client = %this.client;
	
	if(%flag $= "add-ons/Server_NationalFlags/flags/default")
		%client.chatmessage("\c3Serverbot 1.4\c6: Your country has been detected as" SPC %name @ ". Unfortunately, we do not have a flag for that country. You will continue to keep the 'unknown' flag.");
		
	else
		%client.chatmessage("\c3Serverbot 1.4\c6: Your country has been detected as" SPC %name @ ". Your flag has been set appropriately!");
		
	$countryFlag[%name]++;
	export("$countryFlag*", "config/server/countryStats.cs", 0);
			
	%client.clanPrefix = "<bitmap:" @ %flag @ ">" @ %this.clanPrefix;
		
	%this.schedule(0,delete);
}

function matchFlagbyName(%name)
{
	%datablock = "bitmapFlag" @ %name @ "data";
	%datablock = nameToID(%datablock);
	
	if(isObject(%datablock))
		%tex = %datablock.textureName;
		
	else
		%tex = "add-ons/Server_NationalFlags/flags/default";
		
	return %tex;
}